package zero1hd.rhythmbullet.desktop.graphics.ui.pages;

import com.badlogic.gdx.Preferences;
import com.badlogic.gdx.assets.AssetManager;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.ui.ScrollPane;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.utils.ChangeListener;

import zero1hd.rhythmbullet.desktop.graphics.ui.components.GraphicsOptions;
import zero1hd.rhythmbullet.desktop.screens.MainMenu;

public class VideoOptionsPage extends Page {
	private ScrollPane scrollPane;
	private GraphicsOptions graphicsTable;
	private TextButton backButton;
	
	public VideoOptionsPage(Skin skin, Preferences prefs, final MainMenu menu, AssetManager assets) {
		graphicsTable = new GraphicsOptions(menu, skin, prefs);
		scrollPane = new ScrollPane(graphicsTable, skin);
		scrollPane.setFadeScrollBars(false);
		scrollPane.setFillParent(true);
		addActor(scrollPane);
		
		backButton = new TextButton("Back", skin);
		backButton.setPosition(10, getHeight() - 10 - backButton.getHeight());
		backButton.setWidth(backButton.getWidth() + 20);
		backButton.addListener(new ChangeListener() {
			@Override
			public void changed(ChangeEvent event, Actor actor) {
				menu.getCameraPosition().y = 0.5f*getHeight();
			}
		});
		
		addActor(backButton);
	}
	
	@Override
	public void draw(Batch batch, float parentAlpha) {
		super.draw(batch, parentAlpha);
	}
	
	@Override
	public void act(float delta) {
		super.act(delta);
	}
	
	public void save() {
		graphicsTable.save();
	}
}
